
#property copyright "Copyright  2010 Nikolay Zacharenkov"
#property link      ""

#property indicator_chart_window

#include <WinUser32.mqh>
#import "user32.dll"
   int GetParent(int a0);
   int OpenIcon(int a0);
   int BringWindowToTop(int a0);
   int FlashWindow(int a0, int a1);
#import

extern bool Show_Copyright = FALSE;
extern int nPeriod = 60;
extern int FindFor = 15;
extern int Limit = 300;
extern int LabelPoint = 15;
extern bool LabelShow = TRUE;
extern bool OpenWindows_5Point = TRUE;
extern bool Alert_5Point = TRUE;
extern bool OnlyDiver = FALSE;
extern color WolfBullColor = Blue;
extern color WolfBeerColor = Red;
extern color SweetZoneColor = Yellow;
extern int MACDFastEMA = 12;
extern int MACDSlowEMA = 26;
extern int MACDSignalSMA = 9;

int g_timeframe_136;
int gi_140 = 0;
int gi_144 = 0;
int gi_unused_148;
int gi_unused_152;
int gi_unused_156;
int gi_unused_160;
double gd_unused_164;
double gd_unused_172;
double gd_unused_180;
double gd_unused_188;
bool gi_196;
bool gi_200;
bool gi_204;
bool gi_208;
double gd_212;
double gd_220;
double gd_228;
double gd_236;
bool gi_244;
int g_shift_248;
int gi_252;
int gi_256;
double gd_260;
double gd_268;
double gd_276;
double gd_284;
bool gi_292;
int g_shift_296;
int gi_300;
int gi_304;
double gd_308;
double gd_316;
double gd_324;
double gd_332;
double gda_340[6];
int gia_344[6];
double gda_348[6];
int gia_352[6];
bool gi_unused_356 = TRUE;
int gi_360;
int gi_364 = 0;
bool gi_unused_368 = TRUE;
int gi_372 = 0;
int gi_376;
double gd_380;
int gi_388;
double gd_392;
int gi_400;
double gd_404;
int gi_412;
double gd_416;
int g_str2time_424;
bool gi_428 = TRUE;
int g_time_432 = 0;

int init() {
   for (gi_360 = 3; gi_360 <= 5; gi_360++) {
      ObjectCreate("Trend DN-" + gi_360, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet("Trend DN-" + gi_360, OBJPROP_COLOR, WolfBullColor);
      ObjectCreate("Trend UP-" + gi_360, OBJ_TREND, 0, 0, 0, 0, 0);
      ObjectSet("Trend Up-" + gi_360, OBJPROP_COLOR, WolfBeerColor);
   }
   for (gi_360 = 1; gi_360 <= 2; gi_360++) {
      ObjectCreate("LabelWolfBeerS-" + gi_360, OBJ_TEXT, 0, 0, 0);
      ObjectSetText("LabelWolfBeerS-" + gi_360, "se" + gi_360, 12, "Times New Roman", WolfBeerColor);
      ObjectCreate("LabelWolfBullS-" + gi_360, OBJ_TEXT, 0, 0, 0);
      ObjectSetText("LabelWolfBullS-" + gi_360, "su" + gi_360, 12, "Times New Roman", WolfBullColor);
      ObjectCreate("ManyWolf-" + gi_360, OBJ_ARROW, 0, 0, 0);
      ObjectSet("ManyWolf-" + gi_360, OBJPROP_ARROWCODE, SYMBOL_LEFTPRICE);
      ObjectCreate("SweetTriangle-" + gi_360, OBJ_TRIANGLE, 0, 0, 0);
      ObjectSet("SweetTriangle-" + gi_360, OBJPROP_COLOR, SweetZoneColor);
   }
   ObjectCreate("SweetZone-12", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
   ObjectSet("SweetZone-12", OBJPROP_COLOR, WolfBeerColor);
   ObjectSet("SweetZone-12", OBJPROP_BACK, FALSE);
   ObjectSet("SweetZone-12", OBJPROP_RAY, FALSE);
   ObjectSet("SweetZone-12", OBJPROP_WIDTH, 2);
   ObjectCreate("SweetZone-22", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
   ObjectSet("SweetZone-22", OBJPROP_COLOR, WolfBullColor);
   ObjectSet("SweetZone-22", OBJPROP_BACK, FALSE);
   ObjectSet("SweetZone-22", OBJPROP_RAY, FALSE);
   ObjectSet("SweetZone-22", OBJPROP_WIDTH, 2);
   return (0);
}

int deinit() {
   for (gi_360 = 3; gi_360 <= 5; gi_360++) {
      ObjectDelete("Trend UP-" + gi_360);
      ObjectDelete("Trend DN-" + gi_360);
      ObjectDelete("LABELUP-" + gi_360);
      ObjectDelete("LABELDOWN-" + gi_360);
   }
   ObjectDelete("SweetZone-11");
   ObjectDelete("SweetZone-21");
   ObjectDelete("SweetZone-12");
   ObjectDelete("SweetZone-22");
   for (gi_360 = 1; gi_360 <= 4; gi_360++) {
      ObjectDelete("LabelWolfBeerS-" + gi_360);
      ObjectDelete("LabelWolfBullS-" + gi_360);
      ObjectDelete("ManyWolf-" + gi_360);
      ObjectDelete("SweetTriangle-" + gi_360);
   }
   return (0);
}

int start() {
   string lsa_0[256];
   bool li_12;
   string ls_16;
   int li_24;
   if (IsConnected()) {
      if (GetLastError() == 0/* NO_ERROR */) {
         for (int index_4 = 0; index_4 < 256; index_4++) lsa_0[index_4] = CharToStr(index_4);
         if (Show_Copyright == TRUE) {
            Comment(lsa_0[67] + lsa_0[111] + lsa_0[112] + lsa_0[121] + lsa_0[114] + lsa_0[105] + lsa_0[103] + lsa_0[104] + lsa_0[116] + lsa_0[32] + lsa_0[169] + lsa_0[32] + lsa_0[50] +
               lsa_0[48] + lsa_0[49] + lsa_0[48] + lsa_0[44] + lsa_0[32] + lsa_0[78] + lsa_0[105] + lsa_0[107] + lsa_0[111] + lsa_0[108] + lsa_0[97] + lsa_0[121] + lsa_0[32] + lsa_0[90] +
               lsa_0[97] + lsa_0[99] + lsa_0[104] + lsa_0[97] + lsa_0[114] + lsa_0[101] + lsa_0[110] + lsa_0[107] + lsa_0[111] + lsa_0[118]);
         } else Comment(lsa_0[32] + lsa_0[32] + lsa_0[32] + lsa_0[32] + lsa_0[32]);
       /*  g_str2time_424 = StrToTime(lsa_0[50] + lsa_0[48] + lsa_0[49] + lsa_0[50] + "." + lsa_0[48] + lsa_0[52] + "." + lsa_0[51] + lsa_0[48]);
         if (TimeCurrent() > g_str2time_424) {
            Comment("     WolfWavesFind ! \n        .\n E-mail: ikar83@gmail.com, icq: 482-621-975");
            return (0);
         }*/
         gi_372 = FALSE;
         if (f0_0() == 1 || gi_428 == TRUE || g_timeframe_136 != Period()) {
            gi_428 = FALSE;
            gi_372 = TRUE;
            g_timeframe_136 = Period();
            for (gi_360 = 3; gi_360 <= 5; gi_360++) {
               ObjectDelete("Trend UP-" + gi_360);
               ObjectCreate("Trend UP-" + gi_360, OBJ_TREND, 0, 0, 0, 0, 0);
               ObjectSet("Trend Up-" + gi_360, OBJPROP_COLOR, WolfBeerColor);
               ObjectDelete("Trend DN-" + gi_360);
               ObjectCreate("Trend DN-" + gi_360, OBJ_TREND, 0, 0, 0, 0, 0);
               ObjectSet("Trend DN-" + gi_360, OBJPROP_COLOR, WolfBullColor);
            }
            ObjectDelete("SweetZone-12");
            ObjectCreate("SweetZone-12", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
            ObjectSet("SweetZone-12", OBJPROP_COLOR, WolfBeerColor);
            ObjectSet("SweetZone-12", OBJPROP_BACK, FALSE);
            ObjectSet("SweetZone-12", OBJPROP_RAY, FALSE);
            ObjectSet("SweetZone-12", OBJPROP_WIDTH, 2);
            ObjectDelete("SweetZone-22");
            ObjectCreate("SweetZone-22", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
            ObjectSet("SweetZone-22", OBJPROP_COLOR, WolfBullColor);
            ObjectSet("SweetZone-22", OBJPROP_BACK, FALSE);
            ObjectSet("SweetZone-22", OBJPROP_RAY, FALSE);
            ObjectSet("SweetZone-22", OBJPROP_WIDTH, 2);
            for (gi_360 = 1; gi_360 <= 4; gi_360++) {
               ObjectDelete("LabelWolfBeerS-" + gi_360);
               ObjectCreate("LabelWolfBeerS-" + gi_360, OBJ_TEXT, 0, 0, 0);
               ObjectSetText("LabelWolfBeerS-" + gi_360, "se" + gi_360, 12, "Times New Roman", WolfBeerColor);
               ObjectDelete("LabelWolfBullS-" + gi_360);
               ObjectCreate("LabelWolfBullS-" + gi_360, OBJ_TEXT, 0, 0, 0);
               ObjectSetText("LabelWolfBullS-" + gi_360, "su" + gi_360, 12, "Times New Roman", WolfBullColor);
               ObjectDelete("ManyWolf-" + gi_360);
               ObjectCreate("ManyWolf-" + gi_360, OBJ_ARROW, 0, 0, 0);
               ObjectSet("ManyWolf-" + gi_360, OBJPROP_ARROWCODE, SYMBOL_LEFTPRICE);
               ObjectDelete("SweetTriangle-" + gi_360);
               ObjectCreate("SweetTriangle-" + gi_360, OBJ_TRIANGLE, 0, 0, 0);
               ObjectSet("SweetTriangle-" + gi_360, OBJPROP_COLOR, SweetZoneColor);
            }
            gi_unused_148 = 0;
            gi_unused_152 = 0;
            gi_unused_156 = 0;
            gi_unused_160 = 0;
            gd_unused_164 = 0;
            gd_unused_172 = 0;
            gd_unused_180 = 0;
            gd_unused_188 = 0;
            gi_196 = FALSE;
            gi_200 = FALSE;
            gi_204 = FALSE;
            gi_208 = FALSE;
            gd_212 = 0;
            gd_220 = 0;
            gd_228 = 0;
            gd_236 = 0;
            gi_244 = FALSE;
            g_shift_248 = 0;
            gi_252 = 0;
            gi_256 = 0;
            gd_260 = 0;
            gd_268 = 0;
            gd_276 = 0;
            gd_284 = 0;
            gi_292 = FALSE;
            g_shift_296 = 0;
            gi_300 = 0;
            gi_304 = 0;
            gd_308 = 0;
            gd_316 = 0;
            gd_324 = 0;
            gd_332 = 0;
            gi_144 = FALSE;
            gi_140 = FALSE;
            for (int li_8 = FindFor; li_8 < nPeriod; li_8 += 5) {
               if (Bars < Limit) Limit = Bars - li_8;
               for (gi_364 = Limit; gi_364 > 0; gi_364--) {
                  if (Low[gi_364 + (li_8 - 1) / 2] == Low[iLowest(NULL, 0, MODE_LOW, li_8, gi_364)]) {
                     if (gia_344[0] <= gia_352[0] && Low[gi_364 + (li_8 - 1) / 2] < gda_340[0] && gda_340[0] != 0.0) {
                        gda_340[0] = Low[gi_364 + (li_8 - 1) / 2];
                        gia_344[0] = gi_364 + (li_8 - 1) / 2;
                     } else {
                        if (!(gia_344[0] <= gia_352[0] && Low[gi_364 + (li_8 - 1) / 2] >= gda_340[0]) || !(gda_340[0] != 0.0)) {
                           gda_340[5] = gda_340[4];
                           gda_340[4] = gda_340[3];
                           gda_340[3] = gda_340[2];
                           gda_340[2] = gda_340[1];
                           gda_340[1] = gda_340[0];
                           gda_340[0] = Low[gi_364 + (li_8 - 1) / 2];
                           gia_344[5] = gia_344[4];
                           gia_344[4] = gia_344[3];
                           gia_344[3] = gia_344[2];
                           gia_344[2] = gia_344[1];
                           gia_344[1] = gia_344[0];
                           gia_344[0] = gi_364 + (li_8 - 1) / 2;
                        }
                     }
                  }
                  if (High[gi_364 + (li_8 - 1) / 2] == High[iHighest(NULL, 0, MODE_HIGH, li_8, gi_364)]) {
                     if (gia_352[0] <= gia_344[0] && High[gi_364 + (li_8 - 1) / 2] > gda_348[0] && gda_348[0] != 0.0) {
                        gda_348[0] = High[gi_364 + (li_8 - 1) / 2];
                        gia_352[0] = gi_364 + (li_8 - 1) / 2;
                        continue;
                     }
                     if (gia_352[0] <= gia_344[0] && High[gi_364 + (li_8 - 1) / 2] <= gda_348[0] && gda_348[0] != 0.0) continue;
                     gda_348[5] = gda_348[4];
                     gda_348[4] = gda_348[3];
                     gda_348[3] = gda_348[2];
                     gda_348[2] = gda_348[1];
                     gda_348[1] = gda_348[0];
                     gda_348[0] = High[gi_364 + (li_8 - 1) / 2];
                     gia_352[5] = gia_352[4];
                     gia_352[4] = gia_352[3];
                     gia_352[3] = gia_352[2];
                     gia_352[2] = gia_352[1];
                     gia_352[1] = gia_352[0];
                     gia_352[0] = gi_364 + (li_8 - 1) / 2;
                  }
               }
               f0_5(li_8);
               if (gi_144 != FALSE && gi_140 != FALSE) gi_364 = 0;
            }
            if (gi_144 != FALSE && gi_140 != FALSE) li_8 = nPeriod;
         }
         WindowRedraw();

         if ((gi_372 == TRUE && f0_4() == 1) || (f0_7() == 1)) {

         //if (gi_372 == TRUE && f0_4() == 1 || f0_7() == 1) {
            gi_388 = gi_376;
            gd_392 = gd_380;
            gi_412 = gi_400;
            gd_416 = gd_404;
         } else {
            li_12 = FALSE;

            if ((f0_7() == 1 && gi_388 != gi_376) || (gd_392 != gd_380)) li_12 = TRUE;
            if ((f0_4() == 1 && gi_412 != gi_400) || (gd_416 != gd_404)) li_12 = TRUE;

            //if (f0_7() == 1 && gi_388 != gi_376 || gd_392 != gd_380) li_12 = TRUE;
            //if (f0_4() == 1 && gi_412 != gi_400 || gd_416 != gd_404) li_12 = TRUE;
            if (li_12 != FALSE) {
               if (OnlyDiver == TRUE && ObjectGet("ManyWolf-1", OBJPROP_COLOR) != WolfBeerColor) return(0);
               if (OnlyDiver == TRUE && ObjectGet("ManyWolf-2", OBJPROP_COLOR) != WolfBeerColor) return(0);
               if (Alert_5Point == TRUE) {
                  ls_16 = " ";
                  if (Period() == PERIOD_M1) ls_16 = "M1";
                  if (Period() == PERIOD_M5) ls_16 = "M5";
                  if (Period() == PERIOD_M15) ls_16 = "M15";
                  if (Period() == PERIOD_M30) ls_16 = "M30";
                  if (Period() == PERIOD_H1) ls_16 = "H1";
                  if (Period() == PERIOD_H4) ls_16 = "H4";
                  if (Period() == PERIOD_D1) ls_16 = "D1";
                  if (Period() == PERIOD_W1) ls_16 = "W1";
                  if (Period() > PERIOD_W1) ls_16 = "MN";
                  Alert("  ", Symbol(), "(", ls_16, ")   ");
               } else PlaySound("news.wav");
               if (OpenWindows_5Point == TRUE) {
                  li_24 = f0_2();
                  FlashWindow(li_24, 1);
                  li_24 = WindowHandle(Symbol(), 0);
                  li_24 = GetParent(li_24);
                  OpenIcon(li_24);
                  BringWindowToTop(li_24);
               }
               gi_388 = gi_376;
               gd_392 = gd_380;
               gi_412 = gi_400;
               gd_416 = gd_404;
            }
         }
      }
   }
   return (0);
}

void f0_5(int ai_unused_0) {
   double ld_4;
   double ld_12;
   for (int li_20 = 1; li_20 < 5; li_20++) {
      ld_4 = f0_3(gia_344[li_20], gda_340[li_20], gia_352[li_20], gda_348[li_20]);
      ld_12 = f0_3(gia_344[li_20 - 1], gda_340[li_20 - 1], gia_352[li_20 - 1], gda_348[li_20 - 1]);
      if (gi_144 != TRUE && ld_12 < ld_4 && gda_340[li_20] <= gda_340[li_20 - 1] && gda_348[li_20] <= gda_348[li_20 - 1] && gda_340[li_20 - 1] < gda_348[li_20] && gia_344[li_20 - 1] < gia_352[li_20 - 1] &&
         gia_352[li_20 - 1] < gia_344[li_20] && gia_344[li_20] < gia_352[li_20]) {
         if (!(gia_352[li_20] == gi_244 && gda_348[li_20] == gd_260 && gia_352[li_20 - 1] == g_shift_248 && gda_348[li_20 - 1] == gd_268 && gia_344[li_20] == gi_252 && gda_340[li_20] == gd_276 &&
            gia_344[li_20 - 1] == gi_256) || !(gda_340[li_20 - 1] == gd_284)) f0_1(gia_352[li_20], gda_348[li_20], gia_352[li_20 - 1], gda_348[li_20 - 1], gia_344[li_20], gda_340[li_20], gia_344[li_20 - 1], gda_340[li_20 - 1], STYLE_DASH);
      }
      ld_4 = f0_3(gia_352[li_20 + 1], gda_348[li_20 + 1], gia_344[li_20], gda_340[li_20]);
      ld_12 = f0_3(gia_352[li_20], gda_348[li_20], gia_344[li_20 - 1], gda_340[li_20 - 1]);
      if (gi_144 != TRUE && ld_12 < ld_4 && gda_340[li_20] <= gda_340[li_20 - 1] && gda_348[li_20 + 1] <= gda_348[li_20] && gda_340[li_20 - 1] < gda_348[li_20 + 1] && gia_344[li_20] < gia_352[li_20 +
         1] && gia_352[li_20] < gia_344[li_20] && gia_344[li_20] < gia_352[li_20 + 1]) {
         if (!(gia_352[li_20 + 1] == gi_244 && gda_348[li_20 + 1] == gd_260 && gia_352[li_20] == g_shift_248 && gda_348[li_20] == gd_268 && gia_344[li_20] == gi_252 && gda_340[li_20] == gd_276 &&
            gia_344[li_20 - 1] == gi_256) || !(gda_340[li_20 - 1] == gd_284)) f0_1(gia_352[li_20 + 1], gda_348[li_20 + 1], gia_352[li_20], gda_348[li_20], gia_344[li_20], gda_340[li_20], gia_344[li_20 - 1], gda_340[li_20 - 1], STYLE_DASH);
      }
      ld_4 = f0_3(gia_344[li_20], gda_340[li_20], gia_352[li_20], gda_348[li_20]);
      ld_12 = f0_3(gia_344[li_20 - 1], gda_340[li_20 - 1], gia_352[li_20 - 1], gda_348[li_20 - 1]);
      if (gi_140 != TRUE && ld_12 < ld_4 && gda_340[li_20] >= gda_340[li_20 - 1] && gda_348[li_20] >= gda_348[li_20 - 1] && gda_348[li_20 - 1] > gda_340[li_20] && gia_352[li_20 - 1] < gia_344[li_20 - 1] &&
         gia_344[li_20 - 1] < gia_352[li_20] && gia_352[li_20] < gia_344[li_20]) {
         if (!(gia_344[li_20] == gi_292 && gda_340[li_20] == gd_308 && gia_344[li_20 - 1] == g_shift_296 && gda_340[li_20 - 1] == gd_316 && gia_352[li_20] == gi_300 && gda_348[li_20] == gd_324 &&
            gia_352[li_20 - 1] == gi_304) || !(gda_348[li_20 - 1] == gd_332)) {
            if (!(gia_344[li_20] == gi_196 && gda_340[li_20] == gd_212 && gia_344[li_20 - 1] == gi_200 && gda_340[li_20 - 1] == gd_220 && gia_352[li_20] == gi_204 && gda_348[li_20] == gd_228 &&
               gia_352[li_20 - 1] == gi_208) || !(gda_348[li_20 - 1] == gd_236)) f0_6(gia_344[li_20], gda_340[li_20], gia_344[li_20 - 1], gda_340[li_20 - 1], gia_352[li_20], gda_348[li_20], gia_352[li_20 - 1], gda_348[li_20 - 1], STYLE_DASH);
         }
      }
      ld_4 = f0_3(gia_344[li_20 + 1], gda_340[li_20 + 1], gia_352[li_20], gda_348[li_20]);
      ld_12 = f0_3(gia_344[li_20], gda_340[li_20], gia_352[li_20 - 1], gda_348[li_20 - 1]);
      if (gi_140 != TRUE && ld_12 < ld_4 && gda_340[li_20 + 1] >= gda_340[li_20] && gda_348[li_20] >= gda_348[li_20 - 1] && gda_348[li_20 - 1] > gda_340[li_20 + 1] && gia_352[li_20 - 1] < gia_344[li_20] &&
         gia_344[li_20] < gia_352[li_20] && gia_352[li_20] < gia_344[li_20 + 1]) {
         if (gia_344[li_20 + 1] == gi_292 && gda_340[li_20 + 1] == gd_308 && gia_344[li_20] == g_shift_296 && gda_340[li_20] == gd_316 && gia_352[li_20] == gi_300 && gda_348[li_20] == gd_324 &&
            gia_352[li_20 - 1] == gi_304 && gda_348[li_20 - 1] == gd_332) continue;
         if (gia_344[li_20 + 1] == gi_196 && gda_340[li_20 + 1] == gd_212 && gia_344[li_20] == gi_200 && gda_340[li_20] == gd_220 && gia_352[li_20] == gi_204 && gda_348[li_20] == gd_228 &&
            gia_352[li_20 - 1] == gi_208 && gda_348[li_20 - 1] == gd_236) continue;
         f0_6(gia_344[li_20 + 1], gda_340[li_20 + 1], gia_344[li_20], gda_340[li_20], gia_352[li_20], gda_348[li_20], gia_352[li_20 - 1], gda_348[li_20 - 1], STYLE_DASH);
      }
   }
}

double f0_3(int ai_0, double ad_4, int ai_12, double ad_16) {
   double ld_24;
   ld_24 = MathSqrt((ai_0 * Point - ai_12 * Point) * (ai_0 * Point - ai_12 * Point) + (ad_4 - ad_16) * (ad_4 - ad_16));
   return (ld_24);
}

void f0_1(int ai_0, double ad_4, int a_shift_12, double ad_16, int ai_24, double ad_28, int ai_36, double ad_40, int a_style_48) {
   double ld_52;
   double ld_60;
   int li_68;
   int li_unused_72;
   double ld_unused_76;
   int li_unused_84;
   double ld_88;
   if (gi_144 != TRUE) {
      gi_244 = ai_0;
      g_shift_248 = a_shift_12;
      gi_252 = ai_24;
      gi_256 = ai_36;
      gd_260 = ad_4;
      gd_268 = ad_16;
      gd_276 = ad_28;
      gd_284 = ad_40;
      gi_144 = TRUE;
      ObjectSet("Trend Up-3", OBJPROP_STYLE, a_style_48);
      ObjectSet("Trend Up-4", OBJPROP_STYLE, a_style_48);
      ObjectSet("Trend Up-5", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("Trend Up-5", OBJPROP_WIDTH, 2);
      ObjectMove("Trend UP-3", 0, Time[ai_0], ad_4);
      ObjectMove("Trend UP-3", 1, Time[a_shift_12], ad_16);
      ObjectMove("Trend UP-4", 0, Time[ai_24], ad_28);
      ObjectMove("Trend UP-4", 1, Time[ai_36], ad_40);
      ld_52 = ObjectGetValueByShift("Trend UP-3", ai_24) - ObjectGetValueByShift("Trend UP-4", ai_24);
      ld_60 = ObjectGetValueByShift("Trend UP-3", ai_36) - ObjectGetValueByShift("Trend UP-4", ai_36);
      if (ld_52 < ld_60) {
         gi_244 = FALSE;
         gd_260 = 0;
         g_shift_248 = 0;
         gd_268 = 0;
         gi_252 = 0;
         gd_276 = 0;
         gi_256 = 0;
         gd_284 = 0;
         gi_144 = FALSE;
         ObjectDelete("Trend UP-3");
         ObjectCreate("Trend UP-3", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend Up-3", OBJPROP_COLOR, WolfBeerColor);
         ObjectDelete("Trend UP-4");
         ObjectCreate("Trend UP-4", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend Up-4", OBJPROP_COLOR, WolfBeerColor);
         ObjectDelete("Trend UP-5");
         ObjectCreate("Trend UP-5", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend Up-5", OBJPROP_COLOR, WolfBeerColor);
         ObjectDelete("SweetZone-12");
         ObjectCreate("SweetZone-12", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
         ObjectSet("SweetZone-12", OBJPROP_COLOR, WolfBeerColor);
         ObjectSet("SweetZone-12", OBJPROP_BACK, FALSE);
         ObjectSet("SweetZone-12", OBJPROP_RAY, FALSE);
         ObjectSet("SweetZone-12", OBJPROP_WIDTH, 2);
         return;
      }
      ObjectMove("Trend UP-5", 0, Time[ai_0], ad_4);
      ObjectMove("Trend UP-5", 1, Time[ai_36], ad_40);
      ObjectMove("SweetZone-12", 0, Time[ai_24], ad_28);
      ObjectMove("SweetZone-12", 1, Time[ai_36], ad_40);
      ObjectMove("SweetZone-12", 2, Time[a_shift_12], ad_16);
      if (LabelShow == TRUE) {
         ObjectMove("LabelWolfBeerS-1", 0, Time[ai_0], ad_4 + LabelPoint * 2 * Point);
         ObjectMove("LabelWolfBeerS-2", 0, Time[ai_24], ad_28 - LabelPoint * Point);
         ObjectMove("LabelWolfBeerS-3", 0, Time[a_shift_12], ad_16 + LabelPoint * 2 * Point);
         ObjectMove("LabelWolfBeerS-4", 0, Time[ai_36], ad_40 - LabelPoint * Point);
      }
      li_68 = 0;
      li_unused_72 = 0;
      ld_unused_76 = 0;
      li_unused_84 = 1;
      if (g_shift_248 - (gi_252 - gi_256) < 0) li_68 = 0;
      else li_68 = g_shift_248 - (gi_252 - gi_256);
      ObjectMove("SweetTriangle-2", 0, Time[g_shift_248], gd_268);
      ObjectMove("SweetTriangle-2", 1, Time[li_68], ObjectGetValueByShift("Trend UP-3", li_68));
      ld_88 = ObjectGetValueByShift("Trend UP-4", gi_252 - (g_shift_248 - li_68)) - ObjectGetValueByShift("Trend UP-4", gi_252);
      ObjectMove("SweetTriangle-2", 2, Time[li_68], gd_268 + ld_88);
      f0_7();
   }
}

int f0_7() {
   int li_0 = 0;
   int shift_4 = 0;
   double high_8 = 0;
   bool li_ret_16 = FALSE;
   if (g_shift_248 - (gi_252 - gi_256) < 0) li_0 = 0;
   else li_0 = g_shift_248 - (gi_252 - gi_256);
   for (int li_20 = gi_256; li_20 >= li_0; li_20--) {
      if (ObjectGetValueByShift("Trend UP-3", li_20) <= High[li_20]) {
         if (li_ret_16 == FALSE) {
            shift_4 = li_20;
            high_8 = High[li_20];
            li_ret_16 = TRUE;
         }
         if (high_8 < High[li_20]) {
            high_8 = High[li_20];
            shift_4 = li_20;
         }
      }
   }
   if (li_ret_16 == TRUE && gi_144 == TRUE) {
      ObjectMove("ManyWolf-2", 0, Time[shift_4], high_8);
      gi_376 = ObjectGet("ManyWolf-2", OBJPROP_TIME1);
      gd_380 = ObjectGet("ManyWolf-2", OBJPROP_PRICE1);
      if (iMACD(NULL, 0, MACDFastEMA, MACDSlowEMA, MACDSignalSMA, PRICE_HIGH, MODE_MAIN, g_shift_248) - iMACD(NULL, 0, MACDFastEMA, MACDSlowEMA, MACDSignalSMA, PRICE_HIGH,
         MODE_MAIN, shift_4) > 0.0) ObjectSet("ManyWolf-2", OBJPROP_COLOR, WolfBeerColor);
      else ObjectSet("ManyWolf-2", OBJPROP_COLOR, WolfBullColor);
   }
   return (li_ret_16);
}

void f0_6(int ai_0, double ad_4, int a_shift_12, double ad_16, int ai_24, double ad_28, int ai_36, double ad_40, int a_style_48) {
   double ld_52;
   double ld_60;
   int li_68;
   int li_unused_72;
   int li_unused_76;
   double ld_unused_80;
   double ld_88;
   if (gi_140 != TRUE) {
      gi_292 = ai_0;
      g_shift_296 = a_shift_12;
      gi_300 = ai_24;
      gi_304 = ai_36;
      gd_308 = ad_4;
      gd_316 = ad_16;
      gd_324 = ad_28;
      gd_332 = ad_40;
      gi_140 = TRUE;
      ObjectSet("Trend DN-3", OBJPROP_STYLE, a_style_48);
      ObjectSet("Trend DN-4", OBJPROP_STYLE, a_style_48);
      ObjectSet("Trend DN-5", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("Trend DN-5", OBJPROP_WIDTH, 2);
      ObjectMove("Trend DN-3", 0, Time[ai_0], ad_4);
      ObjectMove("Trend DN-3", 1, Time[a_shift_12], ad_16);
      ObjectMove("Trend DN-4", 0, Time[ai_24], ad_28);
      ObjectMove("Trend DN-4", 1, Time[ai_36], ad_40);
      ld_52 = ObjectGetValueByShift("Trend DN-3", ai_24) - ObjectGetValueByShift("Trend DN-4", ai_24);
      ld_60 = ObjectGetValueByShift("Trend DN-3", ai_36) - ObjectGetValueByShift("Trend DN-4", ai_36);
      if (ld_52 > ld_60) {
         gi_292 = FALSE;
         gd_308 = 0;
         g_shift_296 = 0;
         gd_316 = 0;
         gi_300 = 0;
         gd_324 = 0;
         gi_304 = 0;
         gd_332 = 0;
         gi_140 = FALSE;
         ObjectDelete("Trend DN-3");
         ObjectCreate("Trend DN-3", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend DN-3", OBJPROP_COLOR, WolfBullColor);
         ObjectDelete("Trend DN-4");
         ObjectCreate("Trend DN-4", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend DN-4", OBJPROP_COLOR, WolfBullColor);
         ObjectDelete("Trend DN-5");
         ObjectCreate("Trend DN-5", OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet("Trend DN-5", OBJPROP_COLOR, WolfBullColor);
         ObjectDelete("SweetZone-22");
         ObjectCreate("SweetZone-22", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0);
         ObjectSet("SweetZone-22", OBJPROP_COLOR, WolfBullColor);
         ObjectSet("SweetZone-22", OBJPROP_BACK, FALSE);
         ObjectSet("SweetZone-22", OBJPROP_RAY, FALSE);
         ObjectSet("SweetZone-22", OBJPROP_WIDTH, 2);
         return;
      }
      ObjectMove("Trend DN-5", 0, Time[ai_0], ad_4);
      ObjectMove("Trend DN-5", 1, Time[ai_36], ad_40);
      ObjectMove("SweetZone-22", 0, Time[ai_24], ad_28);
      ObjectMove("SweetZone-22", 1, Time[ai_36], ad_40);
      ObjectMove("SweetZone-22", 2, Time[a_shift_12], ad_16);
      if (LabelShow == TRUE) {
         ObjectMove("LabelWolfBullS-1", 0, Time[ai_0], ad_4 - LabelPoint * Point);
         ObjectMove("LabelWolfBullS-2", 0, Time[ai_24], ad_28 + LabelPoint * 2 * Point);
         ObjectMove("LabelWolfBullS-3", 0, Time[a_shift_12], ad_16 - LabelPoint * Point);
         ObjectMove("LabelWolfBullS-4", 0, Time[ai_36], ad_40 + LabelPoint * 2 * Point);
      }
      li_68 = 0;
      li_unused_72 = 1;
      li_unused_76 = 0;
      ld_unused_80 = 0;
      if (g_shift_296 - (gi_300 - gi_304) < 0) li_68 = 0;
      else li_68 = g_shift_296 - (gi_300 - gi_304);
      ObjectMove("SweetTriangle-1", 0, Time[g_shift_296], gd_316);
      ObjectMove("SweetTriangle-1", 1, Time[li_68], ObjectGetValueByShift("Trend DN-3", li_68));
      ld_88 = ObjectGetValueByShift("Trend DN-4", gi_300 - (g_shift_296 - li_68)) - ObjectGetValueByShift("Trend DN-4", gi_300);
      ObjectMove("SweetTriangle-1", 2, Time[li_68], gd_316 + ld_88);
      f0_4();
   }
}

int f0_4() {
   int li_0 = 0;
   bool li_ret_4 = FALSE;
   int shift_8 = 0;
   double low_12 = 0;
   if (g_shift_296 - (gi_300 - gi_304) < 0) li_0 = 0;
   else li_0 = g_shift_296 - (gi_300 - gi_304);
   for (int li_20 = gi_304; li_20 >= li_0; li_20--) {
      if (ObjectGetValueByShift("Trend DN-3", li_20) >= Low[li_20]) {
         if (li_ret_4 == FALSE) {
            shift_8 = li_20;
            low_12 = Low[li_20];
            li_ret_4 = TRUE;
            continue;
         }
         if (low_12 > Low[li_20]) {
            low_12 = Low[li_20];
            shift_8 = li_20;
         }
      }
   }
   if (li_ret_4 == TRUE && gi_140 == TRUE) {
      ObjectMove("ManyWolf-1", 0, Time[shift_8], low_12);
      gi_400 = ObjectGet("ManyWolf-1", OBJPROP_TIME1);
      gd_404 = ObjectGet("ManyWolf-1", OBJPROP_PRICE1);
      if (iMACD(NULL, 0, MACDFastEMA, MACDSlowEMA, MACDSignalSMA, PRICE_LOW, MODE_MAIN, g_shift_296) - iMACD(NULL, 0, MACDFastEMA, MACDSlowEMA, MACDSignalSMA, PRICE_LOW,
         MODE_MAIN, shift_8) < 0.0) ObjectSet("ManyWolf-1", OBJPROP_COLOR, WolfBeerColor);
      else ObjectSet("ManyWolf-1", OBJPROP_COLOR, WolfBullColor);
   }
   return (li_ret_4);
}

int f0_0() {
   if (g_time_432 == 0) {
      g_time_432 = Time[0];
      return (0);
   }
   if (g_time_432 != Time[0]) {
      g_time_432 = Time[0];
      return (1);
   }
   return (0);
}

int f0_2() {
   int li_0 = -1;
   bool li_ret_4 = FALSE;
   while (li_0 <= 0 && !IsStopped()) {
      li_0 = WindowHandle(Symbol(), Period());
      Sleep(500);
   }
   while (!IsStopped()) {
      li_0 = GetParent(li_0);
      if (li_0 == 0) break;
      li_ret_4 = li_0;
   }
   return (li_ret_4);
}